/*===========================================================================*\
| PULLDEMO.C - Full demonstration of pull-down menus.       ver 2.1, 08-01-89 |
|                                                                             |
|   Copyright (c) 1989 James H. LeMay, All rights reserved.                   |
|   Conversion to Turbo C by Jordan Gallagher / Wisdom Research               |
\*===========================================================================*/

#ifdef __TURBOC__
#include <dir.h>
#else
#include <dos.h>
#endif
#include <string.h>

#include "pullc21.h"
#include "pulldemo.h"

#ifdef __TURBOC__
#pragma warn -use
#endif

char origpathname[68];

#ifdef __TURBOC__
static struct {
    char v1;
    int v2;
} _align_;

#if sizeof(_align_)==3
#error Word alignment required
#endif
#endif

void displayscreen(void)
{
    wwrite( 1, 1, "PULLDEMO v2.1             Multi-level Pu"
                  "ll-down Menus       Copr 1989  J H LeMay" );
    showtopline();
    setwindowmodes( PERMMODE );
    makewindow( 3, 1, crt_rows-3, crt_cols, WHITE+BLUE_BG, LIGHTGRAY+BLACK_BG,
                DOUBLE_BORDER, WINDOW1 );
    setwindowmodes(0);
    titlewindow( TOP, LEFT, SAMEATTR, "1" );
    tws.wndwattr = YELLOW+BLUE_BG;
    wwritec( 2, "PULLC21.ARC - MULTI-LEVEL PULL-DOWN MENUS" );
    wwritec( 9, "This is Work Window 1." );
    tws.wndwattr = tws.origattr;
    wwritec( 4, "Use F1 everywhere for some descriptions." );
    wwritec( 5, "Use \"Quit\" to exit demo program.        " );
    wwritec( 6, "Be sure to try a CR at \"\" marked lines." );
    wwritec( 7, "Also try all the EnterData lines.       " );
    wwrite( 11, 9,
            "The following Data Entry fields have some arbitrary values" );
    wwrite( 12, 9,
            "and ranges.  Move the highlight and edit.  Press F1 for help." );
}

void main()
{
#ifndef __TURBOC__
    int t;          /* needed for call to _dos_setdrive */
#endif

/*  qsnow = 0; */
#ifdef MULTIWORKWNDWS
    topworkwndwname=WINDOW1;
#endif
    prefer_multitask=1;              /* Use multi-tasking MTVB if possible. */
    initpull( LIGHTGRAY, 0, 0 );     /* <<-- be sure you do this!! */
    getcwd( origpathname, 67 );
    strcpy( pathname, origpathname );
    displayscreen();
    gotokeydispatcher();      /* <<-- all keyboard entries go through here! */
    if(origpathname!=pathname) {
#ifdef __TURBOC__
        setdisk(origpathname[0]-'A');
#else
        _dos_setdrive(origpathname[0]-'A'+1, &t);
#endif
        chdir(origpathname);
    }
    accesswindow( WINDOW0 );
    wclrscr();
    wgotorc( crt_rows, 1 );
    setcursor( cursor_initial );
}
